theory Regression
imports "../TermFun"
begin

text {* simple recursive identity *}

function f :: "nat \<Rightarrow> nat"
where
  "f 0 = 0"
| "f (Suc n) = Suc (f n)"
by pat_completeness auto

define_trs (no_sim) f.psimps

termination f
apply (trs_reduce f)
apply (simp only: all_trs_defs set_list_conv)
export_termination_problem "TermFunExamples/f.xml"
apply (ceta_import_proof "TermFunExamples/proofs/f.prf.xml")
apply ceta_simp
done

text {* nested case *}

definition predpred :: "nat \<Rightarrow> nat"
where
  "predpred n = (case n of 
    0 \<Rightarrow> 0
  | Suc m \<Rightarrow> case m of 
       0 \<Rightarrow> 0
     | Suc m' \<Rightarrow> m')"

define_trs predpred_def

text {* if *}

function test1 :: "nat \<Rightarrow> nat"
where
  "test1 n = (if n = 0 then 0 else Suc (test1 (n - Suc 0)))"
by pat_completeness auto

define_trs (no_sim) test1.psimps

termination test1
apply (trs_reduce test1) 
apply (simp only: all_trs_defs set_list_conv)
export_termination_problem "TermFunExamples/test1.xml"
(* no termination proof by now 
 apply (ceta_import_proof "TermFunExamples/proofs/test1.prf.xml") 
 apply ceta_checker_simp
*)
oops



end